function psf_convolve,img,sig_psf,psf,nx_psf=nx_psf

; inputs img, sig_psf
; output, lensed image, psf

if not keyword_set(nx_psf) then  nx_psf=fix(10*sig_psf)/2+1

xc_psf=(nx_psf-1.)/2.
yc_psf=xc_psf

; Find out about the image
nx=(size(img))[1]
ny=(size(img))[2]

psf=dblarr(nx_psf,nx_psf)
for i=0,nx_psf-1 do begin
    for j=0,nx_psf-1 do begin
        psf[i,j]=exp(-((i-xc_psf)^2+(j-yc_psf)^2)/(2.*sig_psf^2))
    endfor
endfor
psf=psf/total(psf)

img_smeared=img*0
for i=0,nx-1 do begin
    for j=0,ny-1 do begin
        for i1=0,nx_psf-1 do begin
            di=i1-fix(xc_psf)
            i2=i+di
            for j1=0,nx_psf-1 do begin
                dj=j1-fix(yc_psf)
                j2=j+dj
                if (i2 ge 0 and i2 lt nx and j2 ge 0 and j2 lt nx) then begin
                    img_smeared[i,j]=img_smeared[i,j]+img[i2,j2]*psf[i1+j1*nx_psf]
                endif
            endfor
        endfor
    endfor
endfor


return,img_smeared







end
